﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class Player : MonoBehaviour {
	private Rigidbody2D rb;
    public float axisX;
	public float speed;
    public float mare;
    public float mareNumb;
    private float mareDir;
    public bool canCount;
    private bool dead;
    public float TimeToChangeMare;
    public GameObject colisao;
    public float tempoPulo;
    public bool pulando;
    private Animator anim;
    private bool move;
    private bool right;
    private bool left;
    private bool jump;
    [Header("pontos")]
    public static int pontuacao;
    public static int record;
    public Text pontTxt;
    public Text recoTxt;
	// Use this for initialization
	void Start () {
		rb = GetComponent<Rigidbody2D>();
        anim = GetComponent<Animator>();
        mare = mareNumb;
        StartCoroutine(CountBegin());
        pontuacao = 0;
        record = PlayerPrefs.GetInt("record");
        dead = false;
    }
	
	// Update is called once per frame
	void Update () {
        recoTxt.text = ("recorde  " +record);
        pontTxt.text = ("pontuação  " + pontuacao);
		axisX = Input.GetAxis ("Horizontal");
        //rb.velocity = new Vector2(speed * axisX + mare, rb.velocity.y);
        if (axisX != 0 && !jump)
        {
            move = true;
            if (axisX > 0)
            {
                right = true;
                left = false;
            }
            else
            {
                left = true;
                right = false;
            }
        }
        else {
            move = false;
            right = false;
            right = false;
        }
        

        if (!dead)
        {
            if (!pulando) {
                rb.velocity = new Vector2(speed * axisX + mare, rb.velocity.y);
                if (Input.GetKeyDown(KeyCode.W))
                {
                    rb.velocity = new Vector2(0, rb.velocity.y);
                    StartCoroutine(pulo());
                    soundJump();
                }
            }
            
        }
        //Contador de maré
        if (canCount) {
            mareDir = Random.Range(76, 300);
            if (mareDir > 200)
            {
                //mare lado direito
                mare = mareNumb;
                canCount = false;
                StartCoroutine(CountNow());
            }
            else if (mareDir > 100)
            {
                //mare lado esquerdo
                mare = -mareNumb;
                canCount = false;
                StartCoroutine(CountNow());
            }
            else
            {
                mare = 0;
                //sem mare
                canCount = false;
                StartCoroutine(CountNow());
            }
        }


        anim.SetBool("move", move);
        anim.SetBool("right", right);
        anim.SetBool("left", left);
        anim.SetBool("jump", jump);
        anim.SetBool("dead",dead);
    }
   

    void OnCollisionEnter2D(Collision2D col)
    {
        switch (col.collider.tag) {
            case "Obstaculo":
                if (!pulando) {
                    SoundController.playSound(soundGame.DEATHSONG);
                    StartCoroutine(Morte());
                }
            break;

            case "Wall":
                StartCoroutine(Morte());
                break;
        }
    }

    void OnTriggerEnter2D(Collider2D col)
    {

        switch (col.tag)
        {
            case "Points":
                pontuacao += 10;
                break;
            case "Obstaculo":
                if (!pulando)
                {
                    SoundController.playSound(soundGame.DEATHSONG);
                    StartCoroutine(Morte());
                }
                break;
        }

    }

    IEnumerator CountBegin()
    {
        yield return new WaitForSeconds(1f);
        canCount = true;
    }

    IEnumerator CountNow()
    {
        yield return new WaitForSeconds(TimeToChangeMare);
        canCount = true;
    }

    IEnumerator Morte() {
        dead = true;
        rb.velocity = new Vector2(0,0);
        if(pontuacao > record)
        {
            record = pontuacao;
            PlayerPrefs.SetInt("record", pontuacao);
        }
        yield return new WaitForSeconds(1.5f);
        Debug.Log(PlayerPrefs.GetInt("record"));
        SceneManager.LoadScene("GameOver");
        Destroy(this.gameObject, 0);
    }

    IEnumerator pulo()
    {
        pulando = true;
        jump = true;
        colisao.SetActive(false);
        yield return new WaitForSeconds(tempoPulo);
        colisao.SetActive(true);
        pulando = false;
        jump = false;
    }

    void soundJump()
    {
        SoundController.playSound(soundGame.JUMPK);
    }





}
